aboutsummaryrefslogtreecommitdiff
path: root/tests/tap/kerberos.sh
diff options
context:
space:
mode:
authorRuss Allbery <rra@stanford.edu>2010-02-09 18:40:22 -0800
committerRuss Allbery <rra@stanford.edu>2010-02-09 18:40:22 -0800
commitc02942ddc12408f0e5b9d828cddf240519d1fe93 (patch)
tree62f80e0ba359c1a13cee7daee228e3e00011a723 /tests/tap/kerberos.sh
parentd05f66dbff10b525d37f60ee01d5b9f94bf5192e (diff)
Update to C TAP Harness 1.1 and rra-c-util 3.0 tests
* Update portable and util tests for C TAP Harness 1.1. * Remove the need for Autoconf substitution in test programs. * Support running a single test program with runtests -o. * Properly handle test cases that are skipped in their entirety. * Much improved C TAP library more closely matching Test::More. Rewrite client/basic-t to use the new test library functions and my current test case coding style.
Diffstat (limited to 'tests/tap/kerberos.sh')
-rw-r--r--tests/tap/kerberos.sh48
1 files changed, 48 insertions, 0 deletions
diff --git a/tests/tap/kerberos.sh b/tests/tap/kerberos.sh
new file mode 100644
index 0000000..da07e66
--- /dev/null
+++ b/tests/tap/kerberos.sh
@@ -0,0 +1,48 @@
+# Shell function library to initialize Kerberos credentials
+#
+# Written by Russ Allbery <rra@stanford.edu>
+# Copyright 2009 Board of Trustees, Leland Stanford Jr. University
+#
+# See LICENSE for licensing terms.
+
+# Set up Kerberos, including the ticket cache environment variable. Bail out
+# if not successful, return 0 if successful, and return 1 if Kerberos is not
+# configured. Sets the global principal variable to the principal to use.
+kerberos_setup () {
+ local keytab
+ keytab=''
+ for f in "$BUILD/data/test.keytab" "$SOURCE/data/test.keytab" ; do
+ if [ -r "$f" ] ; then
+ keytab="$f"
+ fi
+ done
+ principal=''
+ for f in "$BUILD/data/test.principal" "$SOURCE/data/test.principal" ; do
+ if [ -r "$f" ] ; then
+ principal=`cat "$BUILD/data/test.principal"`
+ fi
+ done
+ if [ -z "$keytab" ] || [ -z "$principal" ] ; then
+ return 1
+ fi
+ KRB5CCNAME="$BUILD/data/test.cache"; export KRB5CCNAME
+ kinit -k -t "$keytab" "$principal" >/dev/null </dev/null
+ status=$?
+ if [ $status != 0 ] ; then
+ kinit -t "$keytab" "$principal" >/dev/null </dev/null
+ status=$?
+ fi
+ if [ $status != 0 ] ; then
+ kinit -k -K "$keytab" "$principal" >/dev/null </dev/null
+ status=$?
+ fi
+ if [ $status != 0 ] ; then
+ bail "Can't get Kerberos tickets"
+ fi
+ return 0
+}
+
+# Clean up at the end of a test. Currently only removes the ticket cache.
+kerberos_cleanup () {
+ rm -f "$BUILD/data/test.cache"
+}